﻿;
; Input SHA256 : 3A7DBAB11944E530A0EFB310F1A1A4D4F01D14E3C45C20C13AF7B16BF2B7BF6C
; Input MD5    : C55A40CAD80066D2FD19F53EF792E691
; Input CRC32  : 8C5EC22C

; ---------------------------------------------------------------------------
; File Name   : C:\Users\dmitry\Documents\Orion\or_in$
; Format      : Binary file
; Base Address: 0000h Range: A800h - A9C0h Loaded length: 01C0h

; Processor       : z80 []
; Target assembler: Zilog Macro Assembler

; ===========================================================================

; Segment type: Pure code
                segment ROM
                org 0A800h
                ld      a, 42h ; 'B'
                call    byte_BFD6
                ld      hl, aPrm        ; "PRM     "
                call    byte_BFD0
                call    byte_BFE5
                cp      0
                jp      z, loc_A81C
                ld      hl, unk_A96A
                call    byte_F818
                jp      loc_A8B9
; ---------------------------------------------------------------------------

loc_A81C:                               ; CODE XREF: ROM:A810↑j
                ld      a, 9Bh
                ld      (unk_F603), a
                ld      hl, unk_A8CD
                call    byte_F818
                ld      hl, 0
                ld      c, 0
                ld      b, 8

loc_A82E:                               ; CODE XREF: ROM:A833↓j
                ld      a, (unk_F602)
                and     80h
                jp      nz, loc_A82E

loc_A836:                               ; CODE XREF: ROM:A870↓j
                ld      d, 0CBh

loc_A838:                               ; CODE XREF: ROM:A839↓j
                dec     d
                jp      nz, loc_A838

loc_A83C:                               ; CODE XREF: ROM:A84E↓j
                ld      a, (unk_F602)
                and     80h
                add     a, c
                dec     b
                jp      z, loc_A851
                rrca
                ld      c, a
                ld      d, 85h

loc_A84A:                               ; CODE XREF: ROM:A84B↓j
                dec     d
                jp      nz, loc_A84A
                jp      loc_A83C
; ---------------------------------------------------------------------------

loc_A851:                               ; CODE XREF: ROM:A843↑j
                ld      c, a
                ld      (hl), c
                ld      d, 85h

loc_A855:                               ; CODE XREF: ROM:A856↓j
                dec     d
                jp      nz, loc_A855
                ld      de, 300h

loc_A85C:                               ; CODE XREF: ROM:A868↓j
                dec     de
                ld      a, d
                cp      0
                jp      z, loc_A873
                ld      a, (unk_F602)
                and     80h
                jp      nz, loc_A85C
                inc     hl
                ld      c, 0
                ld      b, 8
                jp      loc_A836
; ---------------------------------------------------------------------------

loc_A873:                               ; CODE XREF: ROM:A860↑j
                ld      a, (hl)
                ld      bc, byte_A948
                ld      (bc), a
                dec     hl
                ld      a, (hl)
                ld      bc, byte_A947
                ld      (bc), a
                dec     hl
                dec     hl
                dec     hl
                ld      (word_A949), hl
                ld      de, 0
                ex      de, hl
                call    byte_F82A
                ld      a, b
                ld      hl, byte_A948
                cp      (hl)
                jp      nz, loc_A8C4
                ld      a, c
                ld      hl, byte_A947
                cp      (hl)
                jp      nz, loc_A8C4
                ld      a, 42h ; 'B'
                call    byte_BFD6
                ld      hl, aPrm        ; "PRM     "
                call    byte_BFD0
                ld      de, 0
                ld      hl, (word_A949)
                ex      de, hl
                call    byte_BFCA
                call    byte_BFF7
                ld      hl, unk_A91D
                call    byte_F818

loc_A8B9:                               ; CODE XREF: ROM:A819↑j
                                        ; ROM:A8C1↓j ...
                call    byte_F803
                cp      0Dh
                jp      z, word_BFFD
                jp      loc_A8B9
; ---------------------------------------------------------------------------

loc_A8C4:                               ; CODE XREF: ROM:A890↑j
                                        ; ROM:A898↑j
                ld      hl, unk_A94B
                call    byte_F818
                jp      loc_A8B9
; ---------------------------------------------------------------------------
unk_A8CD:       db  1Fh                 ; DATA XREF: ROM:A821↑o
aDannyeBudutSoh:.ascii 'dannye budut sohraneny w fajle  PRM\r\n'
                .ascii '\n'
                .ascii 'zapustite programmu pereda~i IBM',0
aPrm:           .ascii 'PRM     '       ; DATA XREF: ROM:A805↑o
                                        ; ROM:A8A0↑o
unk_A91D:       db  1Fh                 ; DATA XREF: ROM:A8B3↑o
aFajlPrinqtBezO:.ascii 'fajl prinqt  bez o{ibok !\r\n'
                .ascii '\n'
                .ascii 'wyhod - [wk]',0
byte_A947:      db 0                    ; DATA XREF: ROM:A87A↑o
                                        ; ROM:A894↑o
byte_A948:      db 0                    ; DATA XREF: ROM:A874↑o
                                        ; ROM:A88C↑o
word_A949:      dw 0                    ; DATA XREF: ROM:A881↑w
                                        ; ROM:A8A9↑r
unk_A94B:       db  1Fh                 ; DATA XREF: ROM:loc_A8C4↑o
aOIbkaPriemaWyh:.ascii 'o{ibkA priema!\r\n'
                .ascii '\n'
                .ascii 'wyhod - [wk]',0
unk_A96A:       db  1Fh                 ; DATA XREF: ROM:A813↑o
aNeobhodimoUniT:.ascii '\n'
                .ascii 'neobhodimo uni~tovitx ili pereimenowatx\r\n'
                .ascii 'fajl  " PRM " !\r\n'
                .ascii '\n'
                .ascii '\n'
                .ascii 'wyhod - [wk]',0
                align 40h
; end of 'ROM'

; ===========================================================================

; Segment type: Regular
                segment ORDOS
                org 0B800h
                ds 7CAh
byte_BFCA:      ds 3
                ds 3
byte_BFD0:      ds 3
                ds 3
byte_BFD6:      ds 3
                ds 3
                ds 3
                ds 3
                ds 3
byte_BFE5:      ds 3
                ds 3
                ds 3
                ds 3
                ds 3
                ds 3
byte_BFF7:      ds 3
                ds 3
word_BFFD:      ds 2
; end of 'ORDOS'

; ===========================================================================

; Segment type: Regular
                segment IO
                org 0F600h
                ds 1
                ds 1
unk_F602:       ds 1
unk_F603:       ds 1
                ds 0FBh
; end of 'IO'

; ===========================================================================

; Segment type: Regular
                segment BIOS
                org 0F800h
                ds 3
byte_F803:      ds 3
                ds 12h
byte_F818:      ds 3
                ds 0Fh
byte_F82A:      ds 3
                ds 7D2h
; end of 'BIOS'


                end
