﻿;
; Input SHA256 : 9FC6C6881B385B0BE820497FB94951CE12C3B0239099BD8E4A304A4D8302506C
; Input MD5    : 1165D3A31239BB3DE9F049B7685C0345
; Input CRC32  : DE7126F8

; File Name   : C:\Users\dmitry\Documents\Orion\ibm_out.com
; Format      : MS-DOS COM-file
; Base Address: 1000h Range: 10100h-10340h Loaded length: 240h

                .686p
                .mmx
                .model tiny

; ===========================================================================

; Segment type: Pure code
seg000          segment byte public 'CODE' use16
                assume cs:seg000
                org 100h
                assume es:nothing, ss:nothing, ds:seg000, fs:nothing, gs:nothing

; =============== S U B R O U T I N E =======================================

; Attributes: noreturn

                public start
start           proc near
                mov     ax, 2
                int     10h             ; - VIDEO - SET VIDEO MODE
                                        ; AL = mode
                mov     dx, offset byte_1023F
                mov     ah, 9
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"

loc_1010C:                              ; CODE XREF: start+18↓j
                mov     ah, 0
                int     16h             ; KEYBOARD - READ CHAR FROM BUFFER, WAIT IF EMPTY
                                        ; Return: AH = scan code, AL = character
                cmp     al, 1Bh
                jz      short loc_1011A
                cmp     al, 0Dh
                jz      short loc_1012E
                jmp     short loc_1010C
; ---------------------------------------------------------------------------

loc_1011A:                              ; CODE XREF: start+12↑j
                int     20h             ; DOS - PROGRAM TERMINATION
                                        ; returns to DOS--identical to INT 21/AH=00h
; ---------------------------------------------------------------------------

loc_1011C:                              ; CODE XREF: start+37↓j
                mov     ah, 9
                mov     dx, offset byte_10210
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"
                int     20h             ; DOS - PROGRAM TERMINATION
                                        ; returns to DOS--identical to INT 21/AH=00h
; ---------------------------------------------------------------------------

loc_10125:                              ; CODE XREF: start+4D↓j
                                        ; start+51↓j
                mov     ah, 9
                mov     dx, offset byte_102B3
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"
                int     20h             ; DOS - PROGRAM TERMINATION
                                        ; returns to DOS--identical to INT 21/AH=00h
; ---------------------------------------------------------------------------

loc_1012E:                              ; CODE XREF: start+16↑j
                mov     dx, offset aDr  ; "dr"
                mov     al, 0
                mov     ah, 3Dh
                int     21h             ; DOS - 2+ - OPEN DISK FILE WITH HANDLE
                                        ; DS:DX -> ASCIZ filename
                                        ; AL = access mode
                                        ; 0 - read
                jb      short loc_1011C
                mov     bx, ax
                mov     ah, 'B'
                mov     al, 2
                mov     cx, 0
                mov     dx, 0
                int     21h             ; DOS -
                mov     word_1020E, ax
                cmp     ax, 40000
                ja      short loc_10125
                or      dx, dx
                jnz     short loc_10125
                mov     ah, 'B'
                mov     al, 0
                mov     cx, 0
                mov     dx, 0
                int     21h             ; DOS - 2+ - MOVE FILE READ/WRITE POINTER (LSEEK)
                                        ; AL = method: offset from beginning of file
                mov     ax, ds
                add     ax, 100h
                mov     es, ax
                assume es:nothing
                mov     si, dx
                mov     cx, word_1020E
                push    ds
                push    es
                pop     ds
                assume ds:nothing
                mov     ah, 3Fh
                int     21h             ; DOS - 2+ - READ FROM FILE WITH HANDLE
                                        ; BX = file handle, CX = number of bytes to read
                                        ; DS:DX -> buffer
                pop     ds
                assume ds:seg000
                mov     ax, word_1020E
                mov     si, ax
                mov     es:[si], ax
                inc     si
                inc     si
                mov     di, si
                mov     cx, word_1020E
                mov     ax, 0
                mov     si, ax

loc_10189:                              ; CODE XREF: start:loc_10198↓j
                mov     dl, es:[si]
                add     al, dl
                pushf
                cmp     cx, 1
                jz      short loc_10198
                popf
                adc     ah, dl
                inc     si

loc_10198:                              ; CODE XREF: start+92↑j
                loop    loc_10189
                mov     si, di
                mov     es:[si], ax
                mov     ah, 3Eh
                int     21h             ; DOS - 2+ - CLOSE A FILE WITH HANDLE
                                        ; BX = file handle
                mov     ax, 2
                int     10h             ; - VIDEO - SET VIDEO MODE
                                        ; AL = mode
                mov     dx, offset byte_102E7
                mov     ah, 9
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"
                mov     ax, 83h
                mov     dx, 1
                int     14h             ; SERIAL I/O - INITIALIZE USART
                                        ; AL = initializing parameters, DX = port number (0-3)
                                        ; Return: AH = RS-232 status code bits, AL = modem status bits
                mov     si, 0
                mov     cx, word_1020E
                add     cx, 4

loc_101C1:                              ; CODE XREF: start+DA↓j
                mov     ah, 1
                int     16h             ; KEYBOARD - CHECK BUFFER, DO NOT CLEAR
                                        ; Return: ZF clear if character in buffer
                                        ; AH = scan code, AL = character
                                        ; ZF set if no character in buffer
                jz      short loc_101CD
                mov     ah, 0
                int     16h             ; KEYBOARD - READ CHAR FROM BUFFER, WAIT IF EMPTY
                                        ; Return: AH = scan code, AL = character
                int     20h             ; DOS - PROGRAM TERMINATION
                                        ; returns to DOS--identical to INT 21/AH=00h
; ---------------------------------------------------------------------------

loc_101CD:                              ; CODE XREF: start+C5↑j
                mov     al, es:[si]
                mov     ah, 1
                int     14h             ; SERIAL I/O - TRANSMIT CHARACTER
                                        ; AL = character, DX = port number (0-3)
                                        ; Return: AH = RS-232 status code bits, AL = modem status bits
                and     ah, 80h
                jnz     short loc_101F4
                inc     si
                loop    loc_101C1
                mov     ax, 2
                int     10h             ; - VIDEO - SET VIDEO MODE
                                        ; AL = mode
                mov     ah, 9
                mov     dx, offset byte_10311
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"

loc_101E8:                              ; CODE XREF: start+F0↓j
                mov     ah, 0
                int     16h             ; KEYBOARD - READ CHAR FROM BUFFER, WAIT IF EMPTY
                                        ; Return: AH = scan code, AL = character
                cmp     al, 1Bh
                jz      short loc_101F2
                jmp     short loc_101E8
; ---------------------------------------------------------------------------

loc_101F2:                              ; CODE XREF: start+EE↑j
                int     20h             ; DOS - PROGRAM TERMINATION
                                        ; returns to DOS--identical to INT 21/AH=00h
; ---------------------------------------------------------------------------

loc_101F4:                              ; CODE XREF: start+D7↑j
                mov     ah, 9
                mov     dx, offset byte_102CE
                int     21h             ; DOS - PRINT STRING
                                        ; DS:DX -> string terminated by "$"
                int     20h             ; DOS - PROGRAM TERMINATION
start           endp ; sp-analysis failed ; returns to DOS--identical to INT 21/AH=00h

; ---------------------------------------------------------------------------
aDr             db 'dr',0               ; DATA XREF: start:loc_1012E↑o
                db 0Eh dup(0)
word_1020E      dw 0                    ; DATA XREF: start+47↑w
                                        ; start+68↑r ...
byte_10210      db 94h, 0A0h, 0A9h, 0ABh, 20h, 0ADh, 0A5h, 20h, 0A2h, 20h
                                        ; DATA XREF: start+1E↑o
                db 0E2h, 0A5h, 0AAh, 0E3h, 0E9h, 0A5h, 0ACh, 20h, 0AAh
                db 0A0h, 0E2h, 0A0h, 0ABh, 0AEh, 0A3h, 0A5h, 20h, 0ABh
                db 0A8h, 0A1h, 0AEh, 20h, 0A5h, 0A3h, 0AEh, 20h, 0A8h
                db 0ACh, 0EFh, 20h, 0ADh, 0A5h, 20h, 64h, 72h, 20h, 24h
byte_1023F      db 8Fh, 0A5h, 0E0h, 0A5h, 0A4h, 0A0h, 0E7h, 0A0h, 20h
                                        ; DATA XREF: start+5↑o
                db 0E4h, 0A0h, 0A9h, 0ABh, 0A0h, 20h, 22h, 64h, 72h, 22h
                db 20h, 0A8h, 0A7h, 20h, 0E2h, 0A5h, 0AAh, 0E3h, 0E9h
                db 0A5h, 0A3h, 0AEh, 20h, 0AAh, 0A0h, 0E2h, 0A0h, 0ABh
                db 0AEh, 0A3h, 0A0h, 20h, 0Dh, 0Ah, 8Fh, 0AEh, 0E1h, 0ABh
                db 0A5h, 20h, 0E1h, 0E2h, 0A0h, 0E0h, 0E2h, 0A0h, 20h
                db 0AFh, 0E0h, 0AEh, 0A3h, 0E0h, 0A0h, 2 dup(0ACh), 0EBh
                db 20h, 0AFh, 0E0h, 0A8h, 0A5h, 0ACh, 0A0h, 20h, 0ADh
                db 0A0h, 20h, 8Eh, 0E0h, 0A8h, 0AEh, 0ADh, 0A5h, 2Dh, 31h
                db 32h, 38h, 20h, 2Dh, 20h, 5Bh, 45h, 4Eh, 54h, 45h, 52h
                db 5Dh, 0Dh, 0Ah, 82h, 0EBh, 0E5h, 0AEh, 0A4h, 20h, 2Dh
                db 20h, 5Bh, 20h, 45h, 53h, 43h, 20h, 5Dh, 0Dh, 0Ah, 24h
byte_102B3      db 84h, 0ABh, 0A8h, 0ADh, 0A0h, 20h, 0E4h, 0A0h, 0A9h
                                        ; DATA XREF: start+27↑o
                db 0ABh, 0A0h, 20h, 0A1h, 0AEh, 0ABh, 2 dup(0A5h), 20h
                db 34h, 30h, 20h, 8Ah, 20h, 21h, 0Dh, 0Ah, 24h
byte_102CE      db 0AEh, 0E8h, 0A8h, 0A1h, 0AAh, 0A0h, 20h, 0AFh, 0A5h
                                        ; DATA XREF: start+F6↑o
                db 0E0h, 0A5h, 0A4h, 0A0h, 0E7h, 0A8h, 20h, 0A4h, 0A0h
                db 2 dup(0ADh), 0EBh, 0E5h, 0Ah, 0Dh, 24h
byte_102E7      db 88h, 84h, 85h, 92h, 20h, 8Fh, 85h, 90h, 85h, 84h, 80h
                                        ; DATA XREF: start+A8↑o
                db 97h, 80h, 20h, 84h, 80h, 2 dup(8Dh), 9Bh, 95h, 0Dh
                db 0Ah, 8Eh, 91h, 92h, 80h, 8Dh, 8Eh, 82h, 20h, 2Dh, 20h
                db 5Bh, 0E1h, 0A8h, 0ACh, 0A2h, 0AEh, 0ABh, 5Dh, 20h, 24h
byte_10311      db 8Fh, 85h, 90h, 85h, 84h, 80h, 97h, 80h, 20h, 84h, 80h
                                        ; DATA XREF: start+E3↑o
                db 2 dup(8Dh), 9Bh, 95h, 20h, 87h, 80h, 8Ah, 8Eh, 8Dh
                db 97h, 85h, 8Dh, 80h, 20h, 21h, 0Dh, 0Ah, 82h, 9Bh, 95h
                db 8Eh, 84h, 20h, 2Dh, 20h, 5Bh, 20h, 45h, 53h, 43h, 20h
                db 5Dh, 20h, 24h, 0
seg000          ends


                end start
